//tcpc.c

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "config.h"
#include "tcpc.h"

//
const uint8_t tstbuf[] = {
0x00, 0x00, 0x55, 0xaa, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x77, 
0x33, 0x2e, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x69, 0x00, 0x0a, 0x53, 0x8e, 0x6e,
0xa9, 0x9c, 0xad, 0x35, 0xbe, 0xea, 0x01, 0xaf, 0xb9, 0xdd, 0xa5, 0x47, 0x08, 0x99, 0x80, 0x1e,
0x65, 0x8d, 0x4c, 0x9f, 0x7e, 0xc8, 0x1f, 0x0e, 0x90, 0xb4, 0x56, 0xa0, 0x0c, 0x31, 0xcf, 0x6b,
0xde, 0x28, 0xc4, 0x2b, 0xd8, 0x1f, 0x0f, 0x39, 0xf8, 0x52, 0x41, 0xbe, 0x9d, 0x2b, 0x33, 0x9c,
0x55, 0x79, 0x27, 0x6f, 0x30, 0x9c, 0x8d, 0x40, 0xc7, 0x73, 0x08, 0x46, 0x62, 0xfc, 0xf9, 0xa6,
0x96, 0xf0, 0xaa, 0x2a, 0x59, 0xb2, 0xcf, 0x7c, 0x17, 0x09, 0x49, 0x63, 0xf4, 0xff, 0x7b, 0x54,
0x90, 0x53, 0x74, 0x87, 0x8a, 0x4f, 0x41, 0xb5, 0xb9, 0xee, 0xac, 0x75, 0x1e, 0x9f, 0xe1, 0xf9,
0x1a, 0x4d, 0x66, 0x00, 0x00, 0xaa, 0x55};
//

int TcpConnect(struct sockaddr_in min_clientaddr, int * client)
{
	int res;
	*client = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(*client < 0) {
		#if(_debug2 > 0)
		printf("Create socket error!\n");
		#endif
                return -1;
	}
	min_clientaddr.sin_family = AF_INET;
        min_clientaddr.sin_port = htons(TCPPORT);
	#if(_debug2 > 0)
	printf("TCPconnect: %s:%i\n", inet_ntoa(min_clientaddr.sin_addr), TCPPORT);
	#endif
	res = connect(*client, (struct sockaddr_in *)&min_clientaddr, sizeof(min_clientaddr));
	if(res < 0) {
		#if(_debug2 > 0)
		printf("Connect error: %i !\n", res);
		#endif
		return -2;
	}
	#if(_debug2 > 0)
	printf("TCPconnected: %s !\n", inet_ntoa(min_clientaddr.sin_addr));
	#endif
	//
	return 0;
}

int TcpLoop(int lsock)
{
	int mlsock = lsock;
	int res;
	int iRC                     = 0;
        int iReceiveStatus          = 0;
	int iStillToReceive         = szbuff;
	struct timeval 	ReceiveTimeout;
	fd_set 		fds;
	uint8_t	Buffer[szbuff];
	uint8_t * pBuffer = &Buffer[0];
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        //fd_set 		fds;
	int iMessageLength = sizeof(tstbuf);
	#if(_debug2 > 0)
	int cnt, cnt2;
	printf("Loop...\n\n");
	#endif
	while(1) {
		//установка величины таймаута
        	SendTimeout.tv_sec  = 0;
        	SendTimeout.tv_usec = _wSOCKET_TIMEOUT_;
        	FD_ZERO(&fds);
        	FD_SET(mlsock, &fds);
                iSC = select(mlsock + 1, NULL, &fds, NULL, &SendTimeout);
		if(!iSC) {
			#if(_debug2 > 0)
			printf("Send Timeout\n\n");
			#endif
                        break; //таймаут
		}
                if(iSC < 0) {
			#if(_debug2 > 0)
			printf("Send Error\n\n");
			#endif
                        break; //ошибка
		}
		//iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
		iSendStatus = send(mlsock, &tstbuf[0], iMessageLength, 0);
		if(iSendStatus < 0) {
			break;
		}
		//установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(mlsock, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _rSOCKET_TIMEOUT_;
		iRC = select(mlsock + 1, &fds, NULL, NULL, &ReceiveTimeout);
		//выход по таймауту
                if(!iRC) {
			#if(_debug2 > 0)
			printf("Recv Timeout\n\n");
			#endif
			break;
		}
		//произошла какая то ошибка
                if(iRC < 0) {
			#if(_debug2 > 0)
			printf("Recv Error\n\n");
			#endif
                        break;
		}
		iReceiveStatus = recv(mlsock, (char*)(pBuffer), iStillToReceive, 0);
		if(iReceiveStatus >  0) {
			pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
		}
		else if(iReceiveStatus < 0) {
			break;
		}
		#if(_debug2 > 0)
		printf("RcvLen: %i\n", iReceiveStatus);
		cnt = 0;
		cnt2 = 0;
		while(cnt < iReceiveStatus) {
			if(!(cnt2 < 0x10)) {
				printf("\n");
				cnt2 = 0;
			}
			printf("%02X ", Buffer[cnt]);
			cnt2++;
			cnt++;
		}
		printf("\n\n");
		#endif
		//
		sleep(2);
	}
	close(lsock);
}
