//udps.c

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "config.h"
#include "udps.h"

struct sockaddr_in in_clientaddr;

int UdpListen(void)
{
	int sockfd;
	uint8_t buffer[MAXLINE];
	struct sockaddr_in servaddr, cliaddr;
	int len, n;
	#if(_debug1 > 0)
	int cnt,cnt2;
	#endif
	// Создание дескриптора файла сокета
	if((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0 ) {
		perror("socket creation failed");
		exit(EXIT_FAILURE);
    	}
	memset(&servaddr, 0, sizeof(servaddr));
	memset(&cliaddr, 0, sizeof(cliaddr));
	memset(&in_clientaddr, 0, sizeof(in_clientaddr));
	// Заполнение информации о сервере
	servaddr.sin_family    = AF_INET; // IPv4
	servaddr.sin_addr.s_addr = INADDR_ANY;
	servaddr.sin_port = htons(UDPPORT); 
	// Привязываем сокет с адресом сервера
	if ( bind(sockfd, (const struct sockaddr *)&servaddr, sizeof(servaddr)) < 0 )
	{
		perror("bind failed");
		exit(EXIT_FAILURE);
	}
	//читаем данныеS
	len = sizeof(cliaddr);  // len is value / resuslt
	n = recvfrom(sockfd, (char *)buffer, MAXLINE, MSG_WAITALL, ( struct sockaddr *) &cliaddr, &len);
	in_clientaddr.sin_addr = cliaddr.sin_addr;
	#if(_debug1 > 0)
	printf("IPclient: %s\n", inet_ntoa(in_clientaddr.sin_addr));
	printf("Len: %i\n", n);
	cnt = 0;
	cnt2 = 0;
	while(cnt < n) {
		if(!(cnt2 < 0x10)) {
			cnt2 = 0;
			printf("\n");
		}
		printf("%02X ", buffer[cnt]);
		cnt++;
		cnt2++;
	}
	printf("\n");
	#endif
	//
	return 0;
}


